* Treibersoftware fr Nutzung des EPROM-
* Sequencers zur Bildschirmvergrerung. Die dort
* programmierte Auflsung mu bei den Labels am
* Anfang des Programms eingetragen werden: 

anfang:    bra.w       start
hor_res:   dc.w        768             
ver_res:   dc.w        544  

screenlen: ds.l        1 
physbase:  ds.l        1   
back:      ds.l        1
intout:    ds.l        1

           dc.b        "XBRA"
           dc.b        "NEWV"
oldtrap2:  dc.l        0
mytrap2:   cmp.w       #$73,d0        ;VDI?
           bne.s       normtrap2      ;nein, also
*                         AES; -> Originalroutine
           move.l      d1,a0          ;Zeiger auf
*                            Parameterblock in a0
           move.l      12(a0),intout  ;Zeiger auf
*                              Intout-Feld retten
           move.l      (a0),a0        ;Zeiger auf
*                              Control-Feld holen
           cmp.w       #1,(a0)        ;Funktions-
*                              nummer 1 (OPN_WK)?
           bne.s       normtrap2      ;nein, also
*                              -> Originalroutine
           move.l      2(sp),back     ;sonst Rck
*                            sprungadresse retten
           move.l      #patch,2(sp)   ;und auf
*                     dem Stack herummanipulieren
normtrap2: move.l      oldtrap2,-(sp) ;Original-
*                                routine aufrufen
           rts            

* Beim Rcksprung von V_OPNWK wird der folgende 
* Programmteil durchlaufen:

patch:     dc.w        $A000          ;LINE-A-
*                        Initialisierung aufrufen
           move.l      intout(pc),a1  ;Zeiger auf
*                           Intout-Tabelle zurck

           move.w      ver_res(pc),d0 ;vertikale
*                                 Auflsung holen
           move.w      d0,-4(a0)      ;vertikale
*                  Auflsung in LINE-A einpatchen
           subq.w      #1,d0
           move.w      d0,-$2B2(a0)   ;auch in 
*                   Workstation-Tabelle eintragen
           move.w      d0,2(a1)       ;auch in 
*                                  INTOUT patchen

           move.w      -$2E(a0),d1    ;Zeichen-
*                                      hhe holen
           divu        d1,d0          ;vertikale
*                     Auflsung durch Zeichenhhe
           move.w      d0,-$2A(a0)    ;als Zei-
*                     lenzahl-1 (VT 52) eintragen
                     
           move.w      hor_res(pc),d0 ;horizon-
*                            tale Auflsung holen
           move.w      d0,-$C(a0)     ;in LINE-A 
*                                      einpatchen
           subq.w      #1,d0
           move.w      d0,-$2B4(a0)   ;auch in 
*                         die Workstation-Tabelle
           move.w      d0,(a1)        ;und in 
*                                          INTOUT
           addq.w      #1,d0          ;wird 
*               wieder echte Pixelzahl gebraucht:
            
           lsr.w       #3,d0          ;horizon-
*                          tale Auflsung durch 8
           subq.w      #1,d0
           move.w      d0,-$2C(a0)    ;als Spal-
*                     tenzahl-1 (VT 52) eintragen
           addq.w      #1,d0          ;echte 
*                                     Spaltenzahl
           move.w      d0,-2(a0)      ;als Bild-
*                                 breite in Bytes
           move.w      d0,2(a0)       ;gleich
*                         nochmal (!!) einpatchen
           mulu        d1,d0          ;x Zeichen-
*                          hhe = Bytes/Charzeile
           move.w      d0,-$28(a0)    ;in LINE-A 
*                                       eintragen

* vergrerten Bildschirm lschen von den Mel-
* dungen der vorangegangenen Autoordnerprogramme

           move.l      physbase(pc),a0;Bildspei-
*                                cheranfang holen
           move.l      screenlen,d0   ;soviele
*                               Langworte lschen
           subq.l      #1,d0          ;wegen DBRA
erase:     clr.l       (a0)+
           dbra        d0,erase            

* ab hier wird auf die hhere Auflsung umge-
* schaltet mit Hilfe von Bit Nr. 7 des Soundchips
* (bisher unbenutzt, beim Booten auf 0)

           move.w      sr,-(sp)       ;Status-
*                                register sichern
           or.w        #$700,sr       ;Interrupts
*                                      abschalten
           lea         $FF8800,a0     ;Zeiger auf
*                                       Soundchip
           move.b      #$E,(a0)       ;Port A 
           move.b      (a0),d0        ;auslesen
           or.b        #$80,d0        ;setze Bit7
            
* die folgende Routine ist aus TOS 1.04 abge-
* schrieben. Ohne Synchronisierung auf VSYNC
* geht das Umschalten des Bildschirms schief!

           movem.l     d0-d4/a0-a1,-(sp)
           lea         $FFFFFA21,a0   ;TIMER B
           lea         $FFFFFA1B,a1
           move.b      #$10,(a1)
           moveq       #1,d4 
           move.b      #$0,(a1) 
           move.b      #$F0,(a0)
           move.b      #$8,(a1)
wait1:     move.b      (a0),d0
           cmp.b       d4,d0
           bne.s       wait1
wait2:     move.b      (a0),d4
           move.w      #600,d3        ;falls St-
*      rungen auftreten, mit diesem Wert spielen!
wait3:     cmp.b       (a0),d4       
           bne.s       wait2
           dbra        d3,wait3
           move.b      #$10,(a1)
           movem.l     (sp)+,d0-d4/a0-a1
            
           move.b      d0,2(a0)       ;Port A mit
*                 gesetztem Bit 7 zurckschreiben
           move.w      (sp)+,sr       ;Statusre-
*                              gister zurckholen
           move.l      back(pc),-(sp) ;zurck-
*                                        springen
           rts
            
* Programminitialisierungsteil:
            
start:     move.w      #-1,-(sp)
           move.w      #11,-(sp)      ;Status der
*                            Umschalttasten holen
           trap        #13
           addq.l      #4,sp
           andi.l      #4,d0          ;Control 
*                                       gedrckt?
           bne         abflug         ;ja, daher
*                                 nix instalieren

           move.l      4(sp),a6       ;Basepage-
*                                         adresse
           move.l      #$100,d5       ;Lnge der
*                                        Basepage
           add.l       $C(a6),d5      ;+ Lnge 
*                                       des Codes
           add.l       $14(a6),d5     ;+ Lnge 
*                          des Konstantenbereichs
           add.l       $1C(a6),d5     ;+ Lnge
*                                         des BSS
           lea         stack(pc),a7   ;eigener 
*                                     Stack bitte
            
           moveq       #0,d7          
           move.w      hor_res(pc),d7 ;horizon-
*                            tale Auflsung holen
           lsr.w       #5,d7          ;und durch
*                              32 (Longs!) teilen
           muls        ver_res(pc),d7 ;mal verti-
*                           kale Auflsung nehmen
           dc.w        $A000          ;LINEA-Init
           muls        (a0),d7        ;Anzahl
*                        Bitplanes x Anzahl Longs
           move.l      d7,screenlen   ;fr Lsch-
*                             routine abspeichern

           move.l      d5,-(sp)       ;NEWSIZE
           move.l      a6,-(sp)       ;BLOCKADR
           move.w      #0,-(sp)       ;Nullparam.
           move.w      #74,-(sp)      ;MSHRINK
           trap        #1             ;nicht be-
*                     ntigten Speicher freigeben
           lea         12(sp),sp

           asl.l       #2,d7          ;d7 * 4 = 
*                     Bildschirmspeicher in Bytes
           sub.l       #32000,d7      ;das ist 
*                          der zustzliche Bedarf
           asr.l       #8,d7          ;zustz-
*              lichen Bedarf in Vielfache von 256
           asl.l       #8,d7          ;umrechnen
*           wegen 256-Byte-Grenzen des Videoteils
            
           move.l      #-1,-(sp)      ;wieviel 
*                                Speicher ist da?
           move.w      #72,-(sp)      ;MALLOC()
           trap        #1
           addq.l      #6,sp
           sub.l       d7,d0          ;Bildspei-
*                             cherbedarf abziehen
           bmi         error1         ;zuwenig 
*                       Speicher vorhanden (????)
            
           move.l      d0,-(sp)       ;alles 
*                              brige reservieren
           move.w      #72,-(sp)      ;MALLOC()
           trap        #1
           addq.l      #6,sp
           move.l      d0,d5          ;Anfangs-
*                                adresse aufheben

           move.l      d7,-(sp)       ;Bildspei-
*                   cher-Zusatzbedarf reservieren
           move.w      #72,-(sp)      ;MALLOC()
           trap        #1
           addq.l      #6,sp
           move.l      d0,d4          ;fr Plau-
*                     sibilittsprfung aufheben!
            
           move.l      d5,-(sp)       ;Adresse 
*                                    erster Block
           move.w      #73,-(sp)      ;diesen 
*                          Block wieder freigeben
           trap        #1
           addq.l      #6,sp
                  
           move.w      #2,-(sp)       ;noch aktu-
*                         elle PHYSBASE ermitteln
           trap        #14
           addq.l      #2,sp
            
           sub.l       d7,d0          ;Zusatz-
*                         speicherbedarf abziehen
           cmp.l       d0,d4          ;sollte mit
*                        reservierter Blockgrenze
           bne         error          ;berein-
*                                        stimmen!
            
           move.l      d0,physbase    ;fr spter
*                           zum lschen aufheben!
           move.w      #-1,-(sp)      ;Bild-
*                      schirmspeicher vorverlegen
           move.l      d0,-(sp)
           move.l      d0,-(sp)
           move.w      #5,-(sp)       ;SETSCREEN
           trap        #14
           lea         12(sp),sp

           pea         message1(pc)
           move.w      #9,-(sp)
           trap        #1
           addq.l      #6,sp
            
           pea         install(pc)    ;Vektor-
*                       biegen im Supervisormodus
           move.w      #38,-(sp)
           trap        #14
           addq.l      #6,sp

           clr.w       -(sp)          ;OK zurck
           pea         256+start-anfang
           move.w      #$31,-(sp)
           trap        #1             ;PTERMRES

abflug:    pea         message2(pc)
           move.w      #9,-(sp)
           trap        #1
           addq.l      #6,sp
           clr.w       -(sp)          ;sang- und
*                         klangloses Programmende
           trap        #1

error:     move.l      d4,-(sp)       ;Adresse
*                                   zweiter Block
           move.w      #73,-(sp)      ;diesen
*                          Block wieder freigeben
           trap        #1
           addq.l      #6,sp
error1:    pea         message3(pc)
           move.w      #9,-(sp)
           trap        #1
           addq.l      #6,sp
           clr.w       -(sp)          ;sang- und
*                         klangloses Programmende
           trap        #1
            
install:   move.l      $88,oldtrap2
           move.l      #mytrap2,$88
           rts

            SECTION DATA
            
message1:  dc.b        27,"E",13,10," Bildschirm"
           dc.b        "vergrerung wird akti"
           dc.b        "viert!",13,10,10,0
message2:  dc.b        13,10," Keine Bildschirm"
           dc.b        "vergrerung erwnscht?!"
           dc.b        13,10,10,0
message3:  dc.b        13,10," Bildschirmver"
           dc.b        "grerung konnte nicht"
           dc.b        "in-",13,10," stalliert"
           dc.b        " werden wegen Speicher"
           dc.b        "problemen",13,10,10,0

            SECTION BSS
            
ok:        ds.w        1
           ds.l        512
stack:     ds.l        1

